<?php
if(!defined('ROOT')) die();
define('RETURNCODE', ((isset($_SESSION['blogReturnCode'])) ? $_SESSION['blogReturnCode'] : ''));
if (!empty($_SESSION['commentData'])) {
	$data['commentData'] = $_SESSION['commentData'];
	unset($_SESSION['commentData']);
} else {
	$data['commentData'] = array(
		'author' => '',
		'content' => ''
	);
}

if (!isset($_GET['id'])) {
	$data['numPage'] = ((isset($_GET['page'])) ? $_GET['page'] : 1);
	$_SESSION['lastPageSeen'] = $data['numPage'];
	$data['entryStart'] = ($data['numPage']-1)*$runPlugin->getConfigVal('entry_per_page');
	$data['entryEnd'] = $data['numPage']*$runPlugin->getConfigVal('entry_per_page');
	$blog = new blog($data['entryStart'], $data['entryEnd']);
	$data['metaDescriptionTag'] = 'Liste des billets : ';
	foreach ($blog->getEntries() as $entry) {
		$data['metaDescriptionTag'] .= $entry->getTitle().'; ';
	}
} else {
	$blog = new blog();
	$data['metaDescriptionTag'] = '';
}

$runPlugin->setTitleTag($runPlugin->getConfigVal('title').(isset($data['numPage']) && $data['numPage']>1 ? ' - Page '.$data['numPage'] : ''));
$runPlugin->setMainTitle($runPlugin->getConfigVal('title'));


switch(RETURNCODE) {
	case 'comment0':
		$data['msg'] = 'Le commentaire a bien été enregistré.';
		$data['msgType'] = 'success';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'comment1':
		$data['msg'] = 'Tous les champs doivent être renseignés.';
		$data['msgType'] = 'error';
		$_SESSION['blogReturnCode'] = '';
		break;
	case 'comment2':
		$data['msg'] = 'Le captcha saisi est erroné.';
		$data['msgType'] = 'error';
		$_SESSION['blogReturnCode'] = '';
		break;
	default:
		$data['msg'] = '';
		$data['msgType'] = '';
}

if (ACTION == 'save') {
	if (empty($_POST['author']) || empty($_POST['content'])) {
		$_SESSION['blogReturnCode'] = 'comment1';
		$_SESSION['commentData'] = array(
			'author' => $_POST['author'],
			'content' => $_POST['content']
		);
		header('location:index.php?p=blog&id='.$_GET['id'].'#commentForm');
		die();
	} else {
		if (blogUseCaptcha() && !checkCaptcha()) {
			$_SESSION['blogReturnCode'] = 'comment2';
			$_SESSION['commentData'] = array(
				'author' => $_POST['author'],
				'content' => $_POST['content']
			);
			header('location:index.php?p=blog&id='.$_GET['id'].'#commentForm');
			die();
		} else {
			$comment = new commentEntry();
			$comment->setDate(time());
			$comment->setAuthor($_POST['author']);
			$comment->setContent(htmlentities($_POST['content'], ENT_COMPAT, "UTF-8"));
			$blog->addComment($_GET['id'], $comment);
			$_SESSION['blogReturnCode'] = 'comment0';
			header('location:index.php?p=blog&id='.$_GET['id'].'#comment'.$comment->getId());
			die();
		}
	}
}

if (isset($_GET['id']) && $blog->hasEntry($_GET['id'])) {
	$blog->populateComments($_GET['id']);
	$data['blogEntry'] = $blog->getEntry($_GET['id'])->toArray();
	$runPlugin->setTitleTag($data['blogEntry']['title']);
} else {
	$data['blogList'] = array();
	foreach($blog->getEntries() as $k=>$blogEntry){
		$data['blogList'][$k] = $blogEntry->toArray();
	}
}
?>

<?php include_once(ROOT.'theme/'.$coreConf['theme'].'/header.php') ?>
<?php if (isset($data['blogList'])) { ?>
<div id="blogContent">
	<?php foreach($data['blogList'] as $blogEntry){ ?>
		<div id="entry<?php echo $blogEntry['id']; ?>" class="blogEntry">
			<h2><a href="index.php?p=blog&id=<?php echo $blogEntry['id']; ?>"><?php echo $blogEntry['title']; ?></a></h2>
			<div class="blogEntryInfo">Publié par <?php echo $blogEntry['author']; ?> dans <?php echo blog::getCategory($blogEntry['category']); ?> - <?php echo blogTimeToStr($blogEntry['date']); ?></div>
			<div class="blogEntryContent"><?php echo $blogEntry['content']; ?></div>
			<?php if ($runPlugin->getConfigVal('with_comment')) { ?>
				<div class="blogEntryComments"><a href="index.php?p=blog&id=<?php echo $blogEntry['id']; ?>#comments"><?php echo $blogEntry['nbComments'];?> commentaire(s)</a></div>
			<?php } ?>
		</div>
	<?php } ?>
	<?php if ($blog->hasPreviousEntries($data['entryEnd'])) { ?>
		<p class="fleft"><a href="index.php?p=blog&page=<?php echo ($data['numPage']+1); ?>">&lt;&lt; Billets plus anciens</a></p>
	<?php } ?>
	<?php if ($blog->hasNextEntries($data['numPage'])) { ?>
		<p class="fright"><a href="index.php?p=blog&page=<?php echo ($data['numPage']-1); ?>">Billets plus récents &gt;&gt;</a></p>
	<?php } ?>
</div>
<?php } else { ?>
<div id="blogContent">
	<h2 id="entryTitle"><?php echo $data['blogEntry']['title']; ?></h2>
	<?php if (isset($_SESSION['lastPageSeen'])) { ?>
		<p id="return"><a href="index.php?p=blog&page=<?php echo $_SESSION['lastPageSeen']; ?>">Retour</a></p>
	<?php } ?>
	<div id="entryInfo">Publié par <?php echo $data['blogEntry']['author']; ?> dans <?php echo blog::getCategory($data['blogEntry']['category']); ?> - <?php echo blogTimeToStr($data['blogEntry']['date']); ?></div>
	<div id="entryContent"><?php echo $data['blogEntry']['content']; ?></div>
	<?php if ($runPlugin->getConfigVal('with_comment')) { ?>
		<h3 id="comments">Commentaires</h3>
		<?php foreach ($data['blogEntry']['comments'] as $commentEntry) { ?>
			<?php $commentEntry = $commentEntry->toArray(); ?>
			<div id="comment<?php echo $commentEntry['id']; ?>" class="commentEntry">
				<h4 class="commentNumber">Commentaire #<?php echo $commentEntry['id']; ?></h4>
				<div class="commentInfo"><?php echo $commentEntry['author']; ?> - <?php echo blogTimeToStr($commentEntry['date']); ?></div>
				<div class="commentContent"><?php echo str_replace("\r\n","<br />",$commentEntry['content']); ?></div>
			</div>
		<?php } ?>
		<div id="commentForm">
			<?php showMsg($data['msg'], $data['msgType']); ?>
			<form method="post" action="index.php?p=blog&id=<?php echo $data['blogEntry']['id']; ?>&action=save#commentForm" id="formCommentForm">
				<p><label>Pseudo : <input type="text" name="author" id="c_author" value="<?php echo $data['commentData']['author']; ?>" /></label></p>
				<p><textarea name="content" id="c_content"><?php echo $data['commentData']['content']; ?></textarea></p>
				<?php 
					if (blogUseCaptcha()) {
						showCaptcha();
					}
				?>
				<button id="sendCommentButton">Envoyer</button>
			</form>
		</div>
	<?php } ?>
</div>
	<?php if ($runPlugin->getConfigVal('captcha') == 'javascript') { ?>
<script type="text/javascript">
	var human = false;
	var commentField = document.getElementById('c_content');
	
	function checkHuman() {
		human = true;
		window.onmousemove = null;
		commentField.onkeydown = null;
	}
	
	function confirmHuman(e) {
		if (!human) {
			e.preventDefault();
			return false;
		}
	}
	
	window.onmousemove = checkHuman;
	commentField.onkeydown = checkHuman;
	document.getElementById('formCommentForm').onsubmit = confirmHuman;
</script>
	<?php } ?>
<?php } ?>
<?php include_once(ROOT.'theme/'.$coreConf['theme'].'/footer.php') ?>
