<?php 

class blogEntry{
	private $id;
	private $title;
	private $published;
	private $date;
	private $author;
	private $category;
	private $content;
	private $nbComments;
	private $comments;

	public function __construct($val = array()){
		if(count($val) > 0){
			$this->id = $val['id'];
			$this->title = $val['title'];
			$this->published = (isset($val['published']) ? $val['published'] : true);
			$this->date = (is_numeric($val['date']) ? $val['date'] : blogStrToTime($val['date']));
			$this->author = $val['author'];
			$this->category = (isset($val['category']) ? $val['category'] : -1);
			$this->content = $val['content'];
			$this->nbComments = $val['nbComments'];
		} else {
			$this->published = false;
			$this->category = -1;
			$this->nbComments = 0;
		}
		$this->comments = array();
	}

	public function setId($val){
		$this->id = trim($val);
	}
	public function setTitle($val){
		$this->title = trim($val);
	}
	public function setPublished($val){
		$this->published = trim($val);
	}
	public function setDate($val){
		$this->date = (is_numeric($val) ? $val : blogStrToTime(trim($val)));
	}
	public function setAuthor($val){
		$this->author = trim($val);
	}
	public function setCategory($val){
		$this->category = trim($val);
	}
	public function setContent($val){
		$this->content = trim($val);
	}
	public function setNbComments($val){
		$this->nbComments = trim($val);
	}
	public function setComments($val){
		$this->comments = $val;
	}

	public function getId(){
		return $this->id;
	}
	public function getTitle(){
		return $this->title;
	}
	public function getPublished(){
		return $this->published;
	}
	public function getDate(){
		return $this->date;
	}
	public function getAuthor(){
		return $this->author;
	}
	public function getCategory(){
		return $this->category;
	}
	public function getContent(){
		return $this->content;
	}
	public function getNbComments(){
		return $this->nbComments;
	}
	public function getComments(){
		return $this->comments;
	}
	
	public function toArray() {
		return array(
			'id' => $this->id,
			'title' => $this->title,
			'published' => $this->published,
			'date' => $this->date,
			'author' => $this->author,
			'category' => $this->category,
			'content' => $this->content,
			'nbComments' => $this->nbComments,
			'comments' => $this->comments
		);
	}
}

?>
